#include <stdio.h>
#include <dlfcn.h>
#include <stdlib.h>
#include "dl.h"

#define DEFAULT_LIB "libc.so.6"

void *lib_function(const char *name, const char *soname)
{
    void *rc;
    const char* error;
    void *handle;



    if (!(handle = dlopen(soname ? soname : DEFAULT_LIB, RTLD_LAZY))) {
	fprintf(stderr, "dlopen on %s: %s\n", soname, dlerror());
	exit(1);
    }

    dlerror();			    /* clear the error flag */
    rc = dlsym(handle, name);
    if ((error = dlerror())) {
	fprintf(stderr, "dlsym for %s: %s\n", name, error);
	exit(1);
    }
    dlclose(handle);

    return rc;
}
